PHP笔记 | 异常处理

1. 抛出一个异常

  • 从PHP5开始,PHP支持异常处理异常处理是面向对象一个重要特性
    PHP代码中的异常通过throw抛出,
    异常抛出之后,后面的代码将不会再被执行。
  • 既然抛出异常会中断程序执行,那么为什么还需要使用异常处理?
    异常抛出用于在遇到未知错误
    或者不符合预先设定的条件时,
    通知客户程序,以便进行其他相关处理,不至于使程序直接报错中断。
  • 当代码中使用了try catch的时候,
    抛出的异常会在catch中捕获,否则直接中断
  • 基本语法
    try{
                //可能出现错误或异常的代码
                //catch表示捕获,Exception是php已定义好的异常类
            } catch(Exception $e){
                //对异常处理,方法:
                    //1、自己处理
                    //2、不处理,将其再次抛出
            }

     

  • 处理程序包括:
    Try使用异常的函数应该位于 “try” 代码块内。
    如果没有触发异常,则代码将照常继续执行。
    但是如果异常被触发,会抛出一个异常。
    Throw – 这里规定 如何触发异常
    注意:每一个"throw"必须对应至少一个 "catch"
    当然可以对应多个"catch"
    Catch"catch" 代码块会捕获异常,并创建一个包含异常信息的对象

    //创建可抛出一个异常的函数
    function checkNum($number){
         if($number>1){
             throw new Exception("异常提示-数字必须小于等于1");
         }
         return true;
     }
     
    //在 "try" 代码块中触发异常
     try{
         checkNum(2);
         //如果异常被抛出,那么下面一行代码将不会被输出
         echo '如果能看到这个提示,说明你的数字小于等于1';
     }catch(Exception $e){
         //捕获异常
         echo '捕获异常: ' .$e->getMessage();
     }

     

demo分析:

  • 创建 checkNum()函数。
    检测数字(输入参数)是否大于 1。
    如果是,则抛出一个异常。
  • "try"代码块中调用checkNum()函数。
  • checkNum()函数中的异常被抛出
  • "catch"代码块接收到该异常
    创建一个包含异常信息的对象 ($e)
  • 通过从这个 exception 对象调用$e->getMessage()
    输出来自该异常的错误消息

    <?php
    $filename = 'test.txt';
    try {
        if (!file_exists($filename)) {
          throw new Exception('文件不存在');
        }
    } catch(Exception $e) {
        echo $e->getMessage();
    }
    
    echo '<br>'.'----------------------------------'.'<br>';
    
    function checkNum($number){
         if($number>1){
             throw new Exception("异常提示-数字必须小于等于1");
         }
         return true;
     }
     
    //在 "try" 代码块中触发异常
     try{
         checkNum(2);
         //如果异常被抛出,那么下面一行代码将不会被输出
         echo '如果能看到这个提示,说明你的数字小于等于1';
     }catch(Exception $e){
         //捕获异常
         echo '捕获异常: ' .$e->getMessage();
     }

demo:

文件不存在
----------------------------------
捕获异常: 异常提示-数字必须小于等于1

 


2. 异常处理类

  • PHP具有很多异常处理类
    其中Exception是所有异常处理基类
  • Exception具有几个基本属性与方法,.
    属性:
    message 异常消息内容
    code 异常代码
    file 抛出异常的文件名
    line 抛出异常在该文件的行数方法:
    getTrace 获取异常追踪信息
    getTraceAsString 获取异常追踪信息的字符串
    getMessage 获取出错信息

如果必要的话,可以通过继承Exception类来建立自定义的异常处理类。

//自定义的异常类,继承了PHP的异常基类Exception
class MyException extends Exception {
    function getInfo() {
        return '自定义错误信息';
    }
}

try {
    //使用异常的函数应该位于 "try"  代码块内。如果没有触发异常,则代码将照常继续执行。但是如果异常被触发,会抛出一个异常。
    throw new MyException('error');//这里规定如何触发异常。注意:每一个 "throw" 必须对应至少一个 "catch",当然可以对应多个"catch"
} catch(Exception $e) {//"catch" 代码块会捕获异常,并创建一个包含异常信息的对象
    echo $e->getInfo();//获取自定义的异常信息
    echo $e->getMessage();//获取继承自基类的getMessage信息
}

 

综合demo:

<?php
class MyException extends Exception {
    function getInfo() {
        return '自定义错误信息';
    }
}

try {
    throw new MyException('error');
} catch(Exception $e) {
    echo $e->getInfo().'<br>';
    echo $e->getMessage().'<br>';
    echo $e->getTrace().'<br>';
    echo $e->getTraceAsString();
}

 

运行结果:

自定义错误信息
error
Array
#0 {main}

 


3. 捕获异常信息

  • 可以通过try catch来捕获异常,
    执行的代码放在try代码块中,
    一旦其中的代码抛出异常,就能在catch捕获
  • 在实际应用中,不会轻易的抛出异常,
    只有在极端情况或者非常重要的情况下,才会抛出异常,
    抛出异常,可以保障程序的正确性与安全,避免导致不可预知的bug。

    try {
        //...
    } catch(Exception $ex) {
        //...
    }
    echo '异常处理后,继续执行其他代码';

    注意,对照第一节笔记,try代码块中,抛出异常代码的下一行是不会再执行的;
    try catch后面的代码是可以正常执行,不受影响;(除非catch中代码也错误)


4. 获取错误发生的所在行

  • 实际应用中,通常会获取足够多的异常信息,写入到错误日志中。
    通过将报错的文件名、行号、错误信息、异常追踪信息等记录到日志中,以便调试与修复问题。

demo:

<?php
try {
    throw new Exception('wrong');
} catch(Exception $ex) {
    $msg = 'Error:'.$ex->getMessage()."n";
    $msg.= $ex->getTraceAsString()."n";
    $msg.= '异常行号:'.$ex->getLine()."n";
    $msg.= '所在文件:'.$ex->getFile()."n";
    //将异常信息记录到日志中
    file_put_contents('error.log', $msg);
    echo $msg;
}

运行结果:

Error:wrong
#0 {main}
异常行号:3
所在文件:index.php

 

免责申明:
1. 本站所有教程、文章分享目的仅供大家学习和交流,资源连接来自于网络,非本站发布,本站也不存储任何资源!
2. 如有无法查看或链接失效,烦请报告联系管理员处理!
3. 本站无法保证资源质量及其时效性,恕不接受任何提问。
4.本站即不保存任何资源,也不对任何链接作品负责,希望大家赞助本站,费用仅维持本站的日常运营所需!
5. 百码云无法保证文章教程或资源的完善与安全,请自行检测解决。
6. 通过本站收集链接的相关资源,严禁杜绝任何形式的正式商业用途,请前往官方购买。
7. 但凡通过本站链接导航下载的任何作品,虽不归本站所有,但在研究学习的前提下,请务必在下载24小时后删除。
百码云资源站仅提供学习的平台,所有资料均来自于网络,版权归原创者所有!本站不提供任何保证,并不承担任何法律责任,如果对您的版权或者利益造成损害,请提供相应的资质证明,我们将于3个工作日内予以删除。本文章采用BY-NC-SA 4.0 《国际知识共享署名许可协议4.0》 进行许可 。
百码云 » PHP笔记 | 异常处理

提供互联网优质的资源链接集合站点

关于VIP 站内帮助